#ifndef FOLIUM_X_FO_H
#define FOLIUM_X_FO_H

#include <math.h>
#include "Types.h"

// Template function object class which calculates the x-coordinate
// of a point at a folium for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Folium_x_FO {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;           
    
    Folium_x_FO(NumType_ a = 10.0) : a_(a){}    

    NumType_ operator() (NumType_ t) const {
	if(t==(NumType_) -1.0) 
	  return(3*a_*(-1.001)/(1+power(-1.0001,3)));
	return (3*a_*t)/(1+power(t,3));
    }

private:    
    NumType_ a_;
};
#endif //FOLIUM_X_FO_H
