#ifndef FOLIUM_Y_FO_H
#define FOLIUM_Y_FO_H

#include <math.h>
#include "Types.h"

// Template function object class which calculates the y-coordinate
// of a point at a folium for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Folium_y_FO {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;           
    
    Folium_y_FO(NumType_ a = 10.0) : a_(a){}    

    NumType_ operator() (NumType_ t) const {
	if(t==(NumType_) -1.0) 
	  return(3*a_*power((-1.001), 2)/(1+power((-1.001),3)));
	return (3*a_*power(t,2))/(1+power(t,3));
    }

private:    
    NumType_ a_;
};
#endif //FOLIUM_Y_FO_H
