#include "Helpers.h"

void my_geo_object_dragging(GeoWin& gw, const leda_point& p) {
    geo_scene sc = gw.get_active_scene();
    geo_editor ed = sc ? sc->type_editor() : 0;
    if( !ed ) return;
    if( !ed->start_changing() )
    error_handler(0, "Changing selected objects is not allowed !");
    
    double x = p.xcoord();
    double y = p.ycoord();
    
    double dx, dy, x1,y1;
    unsigned long t = (gw.get_window()).button_press_time();
    int event;

    //fuer update nur bei mouse button down soll die Var auf false sein
    bool my_update_while_object_dragging = false;

    do 
    { 
	int val;
	unsigned long t1;	
	event = (gw.get_window()).read_event(val,x1,y1,t1);
        if (event == motion_event) if (t1 - t < 50) continue;
            
	dx = x1-x; 
	dy = y1-y;		
        ed->move_or_rotate_sel(dx, dy, 0, true, 
			       my_update_while_object_dragging);

		
	if (! my_update_while_object_dragging) {	    
	    geo_scene contr_polyg = gw.get_scene_with_name(
					       leda_string("Control Polygon"));
	    if(contr_polyg) contr_polyg->update();
	    gw.redraw_and_update_status_line();
        }
	t = t1;
	x = x1;
        y = y1;	
    }
    while( event != button_release_event);

    dx = x1-x;     
    dy = y1-y;    
    ed->move_or_rotate_sel(dx, dy, 0, true, true);
  
    ed->stop_changing();    
}

CGAL::Point_2<CGAL::Cartesian<leda_rational> > 
   between_p_q(CGAL::Point_2<CGAL::Cartesian<leda_rational> >& p, 
	       CGAL::Point_2<CGAL::Cartesian<leda_rational> >& q, 
	       leda_rational m_) { 
    leda_rational m = m_.normalize();
    leda_rational _m = (1-m_).normalize();
    CGAL::Point_2<CGAL::Cartesian<leda_rational> > pt(((_m*(p.x()).normalize()).normalize() + 
	      (m*(q.x()).normalize()).normalize()), 
	     ((_m*(p.y()).normalize()).normalize() + 
	      (m*(q.y()).normalize()).normalize()));
    return pt;
}

double _sqrt(leda_rational number) {
    return sqrt((number.normalize()).to_float());
}

double _to_float(leda_rational number) {
    return (number.normalize()).to_float();
}



