#ifndef DRAW_DEMO_H
#define DRAW_DEMO_H

#include <iostream.h>
#include <math.h>
#include "Parametric_curve_2.h"
#include "Bezier_curve_2.h"
#include "B_spline_curve_2.h"
#include "Gerade_x.h"
#include "Gerade_y.h"
#include "Kreis_x.h"
#include "Kreis_y.h"
#include "Zykloide_x.h"
#include "Zykloide_y.h"
#include "Epizykloide_x.h"
#include "Epizykloide_y.h"
#include "Hypozykloide_x.h"
#include "Hypozykloide_y.h"
#include "Arch_helix_x.h"
#include "Arch_helix_y.h"
#include "Hyperbel_helix_x.h"
#include "Hyperbel_helix_y.h"
#include "Witch_x_FO.h"
#include "Witch_y_FO.h"
#include "Folium_x_FO.h"
#include "Folium_y_FO.h"
#include "Tricuspoid_x_FO.h"
#include "Tricuspoid_y_FO.h"
#include "Talbots_curve_x_FO.h"
#include "Talbots_curve_y_FO.h"
#include "Hypotrochoid_x_FO.h"
#include "Hypotrochoid_y_FO.h"
#include "Epitrochoid_x_FO.h"
#include "Epitrochoid_y_FO.h"
#include <CGAL/leda_rational.h>

typedef double num_type;

typedef Gerade_x<num_type> X;
typedef Gerade_y<num_type> Y;
typedef Parametric_curve_2<num_type,X *,Y *> Gerade;

typedef num_type (* lin_func) (num_type);
num_type po_deset(num_type t);

//Parametrci_curve_2 can be instantiated with functions too
typedef Parametric_curve_2<num_type, lin_func, lin_func> Gerade_func;

typedef Kreis_x<num_type> X_k;
typedef Kreis_y<num_type> Y_k;
typedef Parametric_curve_2<num_type, X_k *, Y_k *> Kreis;

typedef double (* trig_func) (num_type);
//Kreis mit Mittelpunkt (0,0) und Radius 1
double kreis_x_func(double t); 
double kreis_y_func(double t); 

typedef Parametric_curve_2<double, trig_func, trig_func> Kreis_func;

typedef Zykloide_x<num_type> X_z;
typedef Zykloide_y<num_type> Y_z;
typedef Parametric_curve_2<num_type, X_z *, Y_z *> Zykloide;

typedef Epizykloide_x<num_type> X_e;
typedef Epizykloide_y<num_type> Y_e;
typedef Parametric_curve_2<num_type, X_e *, Y_e *> Epizykloide;

typedef Hypozykloide_x<num_type> X_h;
typedef Hypozykloide_y<num_type> Y_h;
typedef Parametric_curve_2<num_type, X_h *, Y_h *> Hypozykloide;

typedef Arch_helix_x<num_type> X_ah;
typedef Arch_helix_y<num_type> Y_ah;
typedef Parametric_curve_2<num_type, X_ah *, Y_ah *> Arch_helix;

typedef Hyperbel_helix_x<num_type> X_hh;
typedef Hyperbel_helix_y<num_type> Y_hh;
typedef Parametric_curve_2<num_type, X_hh *, Y_hh *> Hyperbel_helix;

typedef Witch_x_FO<num_type> X_w;
typedef Witch_y_FO<num_type> Y_w;
typedef Parametric_curve_2<num_type, X_w *, Y_w *> Witch;

typedef Folium_x_FO<num_type> X_f;
typedef Folium_y_FO<num_type> Y_f;
typedef Parametric_curve_2<num_type, X_f *, Y_f *> Folium;

typedef Tricuspoid_x_FO<num_type> X_t;
typedef Tricuspoid_y_FO<num_type> Y_t;
typedef Parametric_curve_2<num_type, X_t *, Y_t *> Tricuspoid;

typedef Talbots_curve_x_FO<num_type> X_tc;
typedef Talbots_curve_y_FO<num_type> Y_tc;
typedef Parametric_curve_2<num_type, X_tc *, Y_tc *> Talbots_curve;

typedef Hypotrochoid_x_FO<num_type> X_hy;
typedef Hypotrochoid_y_FO<num_type> Y_hy;
typedef Parametric_curve_2<num_type, X_hy *, Y_hy *> Hypotrochoid;

typedef Epitrochoid_x_FO<num_type> X_et;
typedef Epitrochoid_y_FO<num_type> Y_et;
typedef Parametric_curve_2<num_type, X_et *, Y_et *> Epitrochoid;

typedef Bezier_curve_2<num_type> Bezier;

typedef B_spline_curve_2<num_type> B_spline;

#endif //DRAW_DEMO_H










